package com.emato.cuspay.common.core.db;


import com.emato.cuspay.manager.redis.jedis.cluster.mgt.JedisClusterManager;

public class IdWorkerAide {

	private static IdWorker idWorker;

	public static long nextId() {
		if (idWorker == null) {
			initIdWorker();
		}
		return idWorker.nextId();
	}

	/**
	 * 实例化idWorker
	 */
	private static void initIdWorker() {
		String workerIdKey = "sequence-workerId";
		// 机器id
		Integer workerId = (Integer) JedisClusterManager.instance().getObject(workerIdKey);
		if (workerId == null) {
			workerId = 0;
		}
		String datacenterIdKey = "sequence-datacenterId" + workerId;

		// 数据中心id
		Integer datacenterId = (Integer) JedisClusterManager.instance().getObject(datacenterIdKey);
		if (datacenterId == null) {
			datacenterId = 0;
		} else {
			datacenterId++;
		}

		JedisClusterManager.instance().setObject(workerIdKey, workerId);
		JedisClusterManager.instance().setObject(datacenterIdKey, datacenterId);

		if (datacenterId > 31) {
			datacenterId = 0;
			workerId++;

	 		// 每32 个数据中心id 换一个机器id
			JedisClusterManager.instance().setObject(workerIdKey, workerId);
			datacenterIdKey = "sequence-datacenterId" + workerId;
			JedisClusterManager.instance().setObject(datacenterIdKey, datacenterId);
		}

		idWorker = new IdWorker(workerId, datacenterId);
	}

}
